Bug 73622 - Eliminate Duplicate word at a time equal code in StringImpl.cpp and StringHash.h
Summary: Eliminate Duplicate word at a time equal code in StringImpl.cpp and StringHash.h
Status: RESOLVED FIXED
Alias: None
Product: WebKit
Classification: Unclassified
Component: JavaScriptCore (show other bugs)
Version: 528+ (Nightly build)
Hardware: All All
: P2 Enhancement
Assignee: Michael Saboff
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2011-12-01 22:17 PST by Michael Saboff
Modified: 2011-12-13 08:54 PST (History)
1 user (show)

See Also:


Attachments
Patch (15.11 KB, patch)
2011-12-12 14:13 PST, Michael Saboff
oliver: review+
Details | Formatted Diff | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Michael Saboff 2011-12-01 22:17:33 PST
Both wtf/text/StringHash.h and wtf/text/StringImpl.cpp contain platform specific code to implement equal comparison of two character arrays.

These two versions should be merged together into a common implementation.
Comment 1 Michael Saboff 2011-12-12 14:13:04 PST
Created attachment 118843 [details]
Patch
Comment 2 Oliver Hunt 2011-12-12 15:16:33 PST
Comment on attachment 118843 [details]
Patch

r=me
Comment 3 Michael Saboff 2011-12-12 15:22:08 PST
Committed r102631: <http://trac.webkit.org/changeset/102631>
Comment 4 Darin Adler 2011-12-13 08:54:19 PST
Comment on attachment 118843 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=118843&action=review

> Source/JavaScriptCore/wtf/text/AtomicString.h:142
> +inline bool operator==(const AtomicString& a, const Vector<UChar>& b) { return a.impl() && equal(static_cast<StringImpl*>(a.impl()), b.data(), b.size()); }    

Why is the cast needed?

> Source/JavaScriptCore/wtf/text/StringImpl.h:566
> +template <typename CharTypeL, typename CharTypeR>
> +    ALWAYS_INLINE bool equal(const CharTypeL*, const CharTypeR*, unsigned);

We don’t normally implement the second line like this.

I think that this is too broad an overload for equal. It will allow you to pass any two pointers, including pointers to that aren’t even character types. Instead, I suggest overloading the equal function for all the combinations.
Comment 5 Darin Adler 2011-12-13 08:54:38 PST
(In reply to comment #4)
> > Source/JavaScriptCore/wtf/text/StringImpl.h:566
> > +template <typename CharTypeL, typename CharTypeR>
> > +    ALWAYS_INLINE bool equal(const CharTypeL*, const CharTypeR*, unsigned);
> 
> We don’t normally indent the second line like this.